#include <mcp_can.h>
#include <SPI.h>
#include <Wire.h>
#include "MPU6050_6Axis_MotionApps20.h"
#include <EEPROM.h>
#include <sav_button.h>
#include <Bounce.h>

#define TIME_MOT 1000UL //   Affichage température du liquide de refroidissement 6 secondes
#define TIME_EXT 2000UL //   Affichage température exterieur 6 secondes
#define TIME_INT 3000UL //   Affichage température interieur 6 secondes
#define TIME_BAT 4000UL //   Affichage température interieur 6 secondes
#define TIME_WARNING_BAT 4000UL //   Affichage température interieur 6 secondes
#define TIME_WARNING_TEMPMOTEUR 4000UL //   Affichage température interieur 6 secondes
#define TEMP_LIMIT 100UL
unsigned long int rxId;
int debug=1;
word wbatterie=0;
word limitBatteie=12000;
byte limitEngTemp=80;
byte len = 0;
byte flag2 = 0;
byte batVolt = 0;
byte EngTemp = 0;
byte IntTemp = 0;
byte ExtTemp = 0;
byte s44[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte stmp[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte stmp2[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte rxBuf[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte RTripTimer[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte RTripDistance[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte RFuelConso[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte TxEco[8]    = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
byte TempClim[8]={0, 0, 0, 11, 128, 0, 0, 0}; //TempClim[1]=température*2 min 10°C max 124°C , TempClim[1]=8 tempmin, TempClim[1]=10 tempmax 
byte AccOff[8]={0, 20, 0, 1, 128, 0, 2, 0}; //Acc off deactived
int corroll, corpitch, pitch, roll, pitch2, roll2 = 0; 
int address = 30; // Переменная для хранения адреса

unsigned long TimeSequence; 
unsigned long StartTime;
unsigned long TimeData; 
unsigned long TimeEco2 = 500;
unsigned long LectTimeTemp = 500;
unsigned long TimeCC = 100;
unsigned long TimeBat = 100;
unsigned long TimeAffTemp = 6000;
unsigned int Conso, Vitesse;
bool RefreshData;
byte FlagTemp=1;
byte flag=0;
MPU6050 mpu;
uint8_t mpuIntStatus;   // holds actual interrupt status byte from MPU
uint16_t packetSize;    // expected DMP packet size (default is 42 bytes)
uint16_t fifoCount;     // count of all bytes currently in FIFO
uint8_t fifoBuffer[64]; // FIFO storage buffer
// orientation/motion vars
Quaternion q;           // [w, x, y, z]         quaternion container
VectorFloat gravity;    // [x, y, z]            gravity vector
float ypr[3];           // [yaw, pitch, roll]   yaw/pitch/roll container and gravity vector
unsigned long timeMpu, timeData, delayData, delayData2, time2, time3, timeMpu2   = 0;


MCP_CAN CAN1(5);                                 // CAN1 CS  5
MCP_CAN CAN2(10);                                // CAN2 CS 10
SButton button1(9,50,2000,4000,500); // пин,время антидребезга мс, время длинного нажатия мс, время следующего длиного нажатия, время двойного клика

void setup(){
    Serial.begin(115200);  
    Serial.println("CAN1 BUS setting filters");

    CAN1.init_Mask(0, 0, 0x7ff);                         
    CAN1.init_Filt(0, 0, 0x763);                       
    CAN1.init_Filt(1, 0, 0x763);   

    CAN1.init_Mask(1, 0, 0x7ff);
    CAN1.init_Filt(2, 0, 0x5DA);                      
    CAN1.init_Filt(3, 0, 0x3B7);                      
    CAN1.init_Filt(4, 0, 0x699);                      
    CAN1.init_Filt(5, 0, 0x699);
  
    Serial.println("CAN2 BUS setting filters");
    CAN2.init_Mask(0, 0, 0x7ff);                         
    CAN2.init_Filt(0, 0, 0x31C);                       
    CAN2.init_Filt(1, 0, 0x31C);   

    CAN2.init_Mask(1, 0, 0x7ff);
    CAN2.init_Filt(2, 0, 0x31C);                      
    CAN2.init_Filt(3, 0, 0x31C);                      
    CAN2.init_Filt(4, 0, 0x31C);                      
    CAN2.init_Filt(5, 0, 0x31C);
  
    byte TestPres[8] = {0x02, 0x3e, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00};
    byte ExtDiag[8]  = {0x02,0x10, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00};
    
    while (CAN_OK != CAN2.begin(MCP_STDEXT, CAN_500KBPS, MCP_8MHZ)) {
        Serial.println("CAN2 BUS init error");
        Serial.println("Init CAN2 BUS");
        delay(100);
        }
    Serial.println("CAN2 BUS init ok!");
    CAN2.setMode(MCP_NORMAL);                // Change to normal mode to allow messages to be transmitted
    
    while (CAN_OK != CAN1.begin(MCP_STDEXT, CAN_500KBPS, MCP_8MHZ)) {
       Serial.println("CAN1 BUS init error");
       Serial.println("Init CAN BUS");
       delay(100);
       }
    Serial.println("CAN1 BUS init ok!");
    CAN1.setMode(MCP_NORMAL);                // Change to normal mode to allow messages to be transmitted
/*
    while(!mpu.begin(MPU6050_SCALE_2000DPS, MPU6050_RANGE_2G)){
      Serial.println("MPU6050 not found");
      delay(500);
      }
*/      
    mpu.initialize();              
    mpu.dmpInitialize();
  // supply your own gyro offsets here, scaled for min sensitivity
    mpu.setXGyroOffset(-38); //220
    mpu.setYGyroOffset(-139); //76
    mpu.setZGyroOffset(0); //-85
    mpu.setZAccelOffset(1280); //1788, 1688 factory default for my test chip
    mpu.setDMPEnabled(true);
      // get expected DMP packet size for later comparison
    packetSize = mpu.dmpGetFIFOPacketSize();


    Serial.println("Debut...");
    CAN1.sendMsgBuf(0x743, 0, 8, TestPres);
    CAN1.sendMsgBuf(0x743, 0, 8, ExtDiag);
    delay(100);

    EEPROM.get(address, corroll); // считываем из памяти коррекцию roll 
    address += sizeof(int);
    EEPROM.get(address, corpitch); // считываем из памяти коррекцию pitch
    address = 30;

}

void loop(){
  LecEco2();
  Razeco2();
  Info44();// info 4x4
  Temperature(); 
}
void _log(){
  if (debug==1){
        Serial.print(millis());
        Serial.print(" rxID = ");
        Serial.print(rxId, HEX);
        Serial.print(" { ");
        for (int i = 0; i < 8; i++) {
          Serial.print(rxBuf[i]);
          if (i < 7) Serial.print(", ");
          else  Serial.println(" }");
        }//for
  }
}
void LecEco2(){
  flag=0; 
  const byte TripDist[8]  = {0x03, 0x22, 0x21, 0x01, 0x00, 0x00, 0x00, 0x00};
  const byte FuelUsed[8]  = {0x03, 0x22, 0x21, 0x02, 0x00, 0x00, 0x00, 0x00};
  const byte TripTimer[8] = {0x03, 0x22, 0x21, 0x04, 0x00, 0x00, 0x00, 0x00};
  byte flag = 0; // flag eco2
  //on n'envoie les demandes d'information qu'une seule fois
  CAN1.sendMsgBuf(0x743, 0, 8, TripDist);
  CAN1.sendMsgBuf(0x743, 0, 8, FuelUsed);
  CAN1.sendMsgBuf(0x743, 0, 8, TripTimer);
  while (flag < 7) {
  //on prevoit un timeout pour sortir de la boucle 1000ms
    StartTime = millis(); // start a 'new' counter and 'listen'
    while (CAN_MSGAVAIL == CAN1.checkReceive())  {
      CAN1.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
//      CAN1.readMsgBufID(0x763, &len, rxBuf); // Lecture des donnees: len = data length, buf = data byte(s)
//      rxId = CAN1.getCanId(); //Nous obtenons l'ID du message
      if (rxId == 0x763) { // c'est le bon interlocuteur
      _log();
      if ((rxBuf[1] == 0x62) and (rxBuf[2] == 0x21)) { // on ne traite que les bonnes trames
          switch (rxBuf[3]) {
          case 1:
            RTripDistance[4]=rxBuf[4];
            RTripDistance[5]=rxBuf[5];
            flag = flag | 1;
            break;
          case 2:
            RFuelConso[4]=rxBuf[4];     
            RFuelConso[5]=rxBuf[5]; 
            flag = flag | 2;
            break;
          case 4:
            RTripTimer[4]=rxBuf[4];      
            RTripTimer[5]=rxBuf[5];
            RTripTimer[6]=rxBuf[6];
            flag = flag | 4;
            break;
          } //switch
        } //if 0x62 & 0x21
      }  // if 0x763
    } //while
    if (flag = 7) { // on attend d'avoir les bonnes reponses aux trois requetes
      EnvoiEco2 ();// envoi eco2
      flag = 8;
    }
    if ((millis() - StartTime) > TimeEco2 ){ // timeout toutes les secondes
      flag = 8; 
    }  //on sort du while
  } //while
}
void EnvoiEco2(){
    CalculEco2();
    CAN2.sendMsgBuf(0x314, 0, 8, TxEco);
      if (debug==1){
        Serial.print(millis());
        Serial.print(" TxEco : ");
        Serial.println(" { ");
        for (int i = 0; i < 8; i++) {
          Serial.print(TxEco[i]);
          if (i < 7) Serial.print(", ");
          else  Serial.println(" }");
        }//for
  }
}
void Temperature(){
  TemperatureExt();
  TemperatureMoteur();
  Batterie();
  AffichTemp(); 
}
void Batterie(){
  const byte LectBat[8]  = {0x03, 0x22, 0x20, 0x06, 0x00, 0x00, 0x00, 0x00};
  int flagBat = 0; // flag eco2
  //on n'envoie les demandes d'information qu'une seule fois
  CAN1.sendMsgBuf(0x743, 0, 8, LectBat);
  while (flagBat < 1) {
    StartTime = millis(); 
    while (CAN_MSGAVAIL == CAN1.checkReceive())  {
      CAN1.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
//      CAN1.readMsgBuf(&len, rxBuf); 
//      rxId = CAN1.getCanId();
      _log(); 
        if ((rxId == 0x763) and (rxBuf[1] == 0x62) and (rxBuf[2] == 0x20) and (rxBuf[2] == 0x06)) { // on ne traite que les bonnes trames
         byte HightBatterie=rxBuf[4];
         byte LowBatterie=rxBuf[5];
         wbatterie=word(HightBatterie,LowBatterie);
         batVolt=wbatterie/1000;
            flagBat = 1;
           if (debug==1){
              Serial.print(millis());
              Serial.print(" wbatterie = ");
              Serial.print(wbatterie);
              Serial.print(" batVolt = ");
              Serial.println(batVolt);
            }   
        }
    } //while
    if ((millis() - StartTime) > 500 ){ // timeout toutes les 0,5 secondes
      flagBat = 1; 
    }  //on sort du while
  } //while
  if ((wbatterie < limitBatteie) and (TimeData + TIME_WARNING_BAT <= millis())) {
      TimeData=millis();
    CAN2.sendMsgBuf(0x31B, 0, 8, AccOff);
  }
}
void TemperatureExt(){
  int flagTempExt = 0; // flag eco2
  while (flagTempExt < 1) {
    StartTime = millis(); 
    while (CAN_MSGAVAIL == CAN1.checkReceive())  {
      CAN1.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
//      CAN1.readMsgBuf(&len, rxBuf); 
//      rxId = CAN1.getCanId();
      _log(); 
        if (rxId == 0x3B7) { // on ne traite que les bonnes trames
            ExtTemp=rxBuf[0];
            flagTempExt = 1;
           if (debug==1){
              Serial.print(millis());
              Serial.print(" ExtTemp = ");
              Serial.println(ExtTemp);
            }  
        }
    } //while
    if ((millis() - StartTime) > 500 ){ // timeout toutes les 0,5 secondes
      flagTempExt = 1; 
    }  //on sort du while
  } //while
}
void TemperatureMoteur(){
  int flagTempMot = 0; // flag eco2
  while (flagTempMot < 1) {
    StartTime = millis(); 
    while (CAN_MSGAVAIL == CAN1.checkReceive())  {
      CAN1.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
//      CAN1.readMsgBuf(&len, rxBuf); 
//      rxId = CAN1.getCanId(); 
      _log();
        if (rxId == 0x5DA) { // on ne traite que les bonnes trames
      EngTemp=rxBuf[0];
            if (debug==1){
              Serial.print(millis());
              Serial.print(" EngTemp = ");
              Serial.println(EngTemp);
            }  
            flagTempMot = 1;
        }
    } //while
    if ((millis() - StartTime) > 500 ){ // timeout toutes les 0,5 secondes
      flagTempMot = 1; 
    }  //on sort du while
  } //while
    if ((EngTemp > limitEngTemp) and (TimeData + TIME_WARNING_TEMPMOTEUR <= millis())) {
      TimeData=millis();
      if (EngTemp > 127){EngTemp=127;}
      TempClim[1]=EngTemp*2;
    CAN2.sendMsgBuf(0x31B, 0, 8, TempClim);
  }
}
void AffichTemp(){
    if (FlagTemp==1){
    if(TimeData + TIME_MOT <= millis()) {
      FlagTemp = 2; 
      TimeData=millis();
      RefreshData = true;
    }
  stmp[2]=EngTemp;
  }
  if (FlagTemp==2){
    if(TimeData + TIME_EXT <= millis()) {
      FlagTemp = 3; 
      TimeData=millis();
      RefreshData = true;
    }
  stmp[2]=ExtTemp;
  } 
  if (FlagTemp==3){
    if(TimeData + TIME_INT <= millis()) {
      FlagTemp = 4; 
      TimeData=millis();
      RefreshData = true;
    }
  stmp[2]=IntTemp;
  }
  if (FlagTemp==4){
    if(TimeData + TIME_BAT <= millis()) {
      FlagTemp = 1; 
      TimeData=millis();
      RefreshData = true;
    }
  stmp[2]=batVolt;
  }
  if(RefreshData) {
    CAN2.sendMsgBuf(0x558, 0, 8, stmp);// envoie au bus
    RefreshData=false;
  }
} 
void Info44(){  
  if(timeMpu+5 <= millis()){
    
    timeMpu=millis();
    mpuIntStatus = mpu.getIntStatus();
    // get current FIFO count
    fifoCount = mpu.getFIFOCount();

    // check for overflow (this should never happen unless our code is too inefficient)
    if ((mpuIntStatus & 0x10) || fifoCount == 1024) {
        // reset so we can continue cleanly
        mpu.resetFIFO();
        // otherwise, check for DMP data ready interrupt (this should happen frequently)
    } else if (mpuIntStatus & 0x02) {
        // wait for correct available data length, should be a VERY short wait
        while (fifoCount < packetSize) fifoCount = mpu.getFIFOCount();
        mpu.getFIFOBytes(fifoBuffer, packetSize);
        // track FIFO count here in case there is > 1 packet available
        // (this lets us immediately read more without waiting for an interrupt)
        fifoCount -= packetSize;
    }
   }
     if(timeMpu2+200 <= millis()){
      timeMpu2=millis();
            // display Euler angles in degrees
        mpu.dmpGetQuaternion(&q, fifoBuffer);
        mpu.dmpGetGravity(&gravity, &q);
        mpu.dmpGetYawPitchRoll(ypr, &q, &gravity);      
  

        pitch = round(-ypr[1] * 180/PI);
        roll = round(ypr[2] * 180/PI);
        roll2 = roll-corroll;
        pitch2 = pitch-corpitch;
      
       s44[0] = 0x78 + (min(30, max(-30, roll2)) << 1);
       s44[1] = 0x78 + (min(20, max(-20, pitch2)) << 1);


        
//        pitch = -ypr[1] * 360/M_PI;
//        roll = ypr[2] * 360/M_PI;
//        roll2 = roll-corroll;
//        pitch2 = pitch-corpitch;
        Serial.print(roll);
        Serial.print(" ");
        Serial.print(pitch);
        Serial.print(" ");

        Serial.print(roll2);
        Serial.print(" ");
        Serial.print(pitch2);
        Serial.println(" ");

//       info44[0] = 0x78 + (min(30, max(-30, roll2)) << 1);
//       info44[1] = 0x78 + (min(20, max(-20, pitch2)) << 1);
    // отправляем pitch и roll
    CAN2.sendMsgBuf(0x407, 0, 8, s44);
    }
 
/*
    Vector normAccel = mpu.readNormalizeAccel();

  // Calcule Pitch & Roll
    pitch = -(atan2(normAccel.XAxis, sqrt(normAccel.YAxis*normAccel.YAxis + normAccel.ZAxis*normAccel.ZAxis))*180.0)/M_PI;
    roll = (atan2(normAccel.YAxis, normAccel.ZAxis)*180.0)/M_PI;


//        pitch = round(-ypr[1] * 180/PI);
//        roll = round(ypr[2] * 180/PI);
        roll2 = roll-corroll;
        pitch2 = pitch-corpitch;
      
//       info44[0] = 0x78 + (min(30, max(-30, roll2)) << 1);
//       info44[1] = 0x78 + (min(20, max(-20, pitch2)) << 1);
 
//    if(roll>30)
//        roll=30;
//    if(pitch>30)
//        pitch=30;
          
 //   if(roll<-30)
 //       roll=-30;
 //   if(pitch<-30)
 //       pitch=-30;
 //   if (debug==1){
      Serial.print(millis());
      Serial.print(" roll = ");
      Serial.print(roll);
      Serial.print(" pitch = ");
      Serial.println(pitch);
      
//    s44[0]=0x78+roll*2;
//    s44[1]=0x78+pitch*2;

      s44[0] = 0x78 + (min(30, max(-30, roll2)) << 1);
      s44[1] = 0x78 + (min(20, max(-20, pitch2)) << 1);
    
    // envoie pitch et roll
    CAN2.sendMsgBuf(0x407, 0, 8, s44);  

*/
}

void Razeco2(){
  int Razeco2 = 0; // flag eco2
  while (Razeco2 < 1) {
    StartTime = millis(); 
    while (CAN_MSGAVAIL == CAN1.checkReceive())  {
      CAN2.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
//      CAN2.readMsgBuf(&len, rxBuf); 
//      rxId = CAN2.getCanId();
      _log(); 
      if(rxId == 0x31C) { // on ne traite que les bonnes trames
        Razeco2 = 1;
      if(rxBuf[2]==0x80){
        CAN1.sendMsgBuf(0x433, 0, 8, rxBuf);
        if (debug==1){
            Serial.print(millis());
            Serial.println(" RAZ = ok");
        }
      }
        }
    } //while
    if ((millis() - StartTime) > 500 ){ // timeout toutes les 0,5 secondes
      Razeco2 = 1; 
    }  //on sort du while
  } //while 
}

void CalculEco2(){
    word wTriptimer, wTripdistance, wTripConsumption, TripAvarageSpeed, TripAverageConsumption;
    float Calcul;

    wTriptimer = word( RTripTimer[5], RTripTimer[6] );
    wTripdistance = word( RTripDistance[4], RTripDistance[5] );
    wTripConsumption = word( RFuelConso[4], RFuelConso[5] );

// vitesse moyenne
    Calcul = round( wTripdistance * 36000 / ( RTripTimer[4]  * 65536 + wTriptimer ));
    TripAvarageSpeed = (word) Calcul;
    TripAvarageSpeed = TripAvarageSpeed << 4;
    TxEco[7] = lowByte(TripAvarageSpeed) | (TxEco[7] & 0x0F );
    TxEco[6] = highByte(TripAvarageSpeed);

// conso moyenne
    Calcul = round( 50.0 * wTripConsumption / wTripdistance );
    TripAverageConsumption = (word) Calcul; // ou essayer word(calcul)
    TxEco[1] = lowByte(TripAverageConsumption) ;
    TxEco[0] = (TxEco[0] & 0xFC ) | (highByte(TripAverageConsumption) & 0x03) ;

// volume de carburant
    wTripConsumption = ( ( wTripConsumption >> 1 ) & 0x7FFF );
    TxEco[5] = lowByte(wTripConsumption);
    TxEco[4] = highByte(wTripConsumption) ;

// distance parcourue
    wTripdistance=wTripdistance * 5;
    TxEco[3] = lowByte(wTripdistance) ;
    TxEco[2] = highByte(wTripdistance) ;
 }

void Button() {
   // секция кнопки
   
   switch( button1.Loop() ){
/*
    case CLICK:
    if(flag3==1){flag3=0;}
    flag=flag+1;
    if(flag>4){flag=1;}
    stmp3[2]=flag2;
    if(flag==1){stmp3[3]=0x18;}
    if(flag==2){stmp3[3]=0x28;}
    if(flag==3){stmp3[3]=0x38;}
    if(flag==4){stmp3[3]=0x48;}
    CAN2.sendMsgBuf(0x31B, 0, 8, stmp3); 
    refreshData2 = true;
    break;

    case DOUBLE_CLICK:
    if(flag3==0){flag3=1;}
    stmp3[2]=flag2;
    stmp3[3]=0x58;
    CAN2.sendMsgBuf(0x31B, 0, 8, stmp3);
    break;

    case LONG_CLICK:
    stmp3[2]=flag2;
    for (int i = 0; i < 113; i = i + 16){
    stmp3[3]=0x18+i;
    CAN2.sendMsgBuf(0x31B, 0, 8, stmp3);
    delay(100);   
   }
    break;
    
    case LONG_CLICK_OFF:
    EEPROM.update(address3,flag3);
    if(flag3==0){EEPROM.update(address2,flag);}
    break;
*/    
    case AUTO_CLICK:
    corroll = roll;
    corpitch = pitch;
   EEPROM.put(address, corroll);
     address += sizeof(int);
   EEPROM.put(address, corpitch);
   address=30;
/*   
   stmp3[2]=flag2;
   for (int i = 0; i < 113; i = i + 16){
    stmp3[3]=0x18+i;
    CAN2.sendMsgBuf(0x31B, 0, 8, stmp3);
    delay(100);   
*/    
     break;
   } 
}
 
